#include <bits/stdc++.h>
using namespace std;

int main(){
	int n,q;
	cin>>n>>q;
	string s;
	cin>>s;
	int levo,r;
	for(int i=0;i<q;i++){
		cin>>levo>>r;
		int resenje=0;
		bool prvi=false;
		int br_6=0,br_7=0;
		for (int l=levo-1;l<r;l++){
			for (int x=levo-1;x<r;x++){
				if(s[x]=='?' && !prvi){
				s[x]='6';
				prvi=true;
			}
				else if(s[x]=='?' && prvi){
					s[x]='7';
				}
			}
			if(s[l]=='6')br_6++;
			else br_7++;
		}
		int pomocna_poz=0;
		for (int l=levo-1;l<r;l++){
			if(s[l]=='6' && l!=r-1){
				br_7-=l-pomocna_poz+1;
				resenje+=br_7;
				pomocna_poz=l;
			}
		}
		cout<<resenje<<endl;
	}
}